MyGUI: MyGUI::Button Class Reference

MyGUI 3.4.3

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions
MyGUI::Button Class Reference

widget description should be here. More...

`#include <MyGUI_Button.h>`

Inheritance diagram for MyGUI::Button:
[legend]

## Public Types
typedef RTTIBase | Base
typedef Button | RTTIBase
Public Types inherited from MyGUI::TextBox
typedef RTTIBase | Base
typedef TextBox | RTTIBase
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual std::string_view | getTypeName () const override
virtual bool | isType (const std::type_info &_type) const override
template<typename Type>
bool | isType () const
void | setStateSelected (bool _check)
| Set button selected state.
bool | getStateSelected () const
| Get buton selected.
void | setModeImage (bool _value)
bool | getModeImage () const
void | setImageResource (std::string_view _name)
void | setImageGroup (std::string_view _name)
void | setImageName (std::string_view _name)
void | _setKeyFocus (bool _focus)
void | _setMouseFocus (bool _focus)
ImageBox * | _getImageBox () const
Public Member Functions inherited from MyGUI::TextBox
template<typename Type>
bool | isType () const
virtual IntCoord | getTextRegion () const
virtual IntSize | getTextSize () const
virtual void | setCaption (const UString &_caption)
virtual const UString & | getCaption () const
virtual void | setFontName (std::string_view _value)
std::string_view | getFontName () const
virtual void | setFontHeight (int _height)
virtual int | getFontHeight () const
virtual void | setTextAlign (Align _value)
Align | getTextAlign () const
virtual void | setTextColour (const Colour &_value)
const Colour & | getTextColour () const
void | setCaptionWithReplacing (std::string_view _value)
virtual void | setTextShadowColour (const Colour &_value)
const Colour & | getTextShadowColour () const
virtual void | setTextShadow (bool _value)
bool | getTextShadow () const
Public Member Functions inherited from MyGUI::Widget
template<typename Type>
bool | isType () const
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetT (std::string_view _type, std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
Widget * | createWidgetRealT (std::string_view _type, std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidget (std::string_view _skin, int _left, int _top, int _width, int _height, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, const FloatCoord &_coord, Align _align, std::string_view _name={})
template<typename T>
T * | createWidgetReal (std::string_view _skin, float _left, float _top, float _width, float _height, Align _align, std::string_view _name={})
Widget * | createWidgetT (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
template<typename T>
T * | createWidget (WidgetStyle _style, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
void | setPosition (const IntPoint &_point) override
void | setSize (const IntSize &_size) override
void | setCoord (const IntCoord &_coord) override
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_point)
void | setRealSize (const FloatSize &_size)
void | setRealCoord (const FloatCoord &_coord)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget.
virtual void | setVisible (bool _value)
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _alpha)
float | getAlpha () const
void | setInheritsAlpha (bool _inherits)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount () const
Widget * | getChildAt (size_t _index) const
Widget * | findWidget (std::string_view _name)
void | findWidgets (std::string_view _name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord () const
Widget * | getClientWidget ()
const Widget * | getClientWidget () const
void | detachFromWidget (std::string_view _layer={})
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, std::string_view _layer={})
void | changeWidgetSkin (std::string_view _skinName)
void | setWidgetStyle (WidgetStyle _style, std::string_view _layer={})
WidgetStyle | getWidgetStyle () const
void | setProperty (std::string_view _key, std::string_view _value)
virtual size_t | _getItemIndex (Widget *_item) const
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, std::string_view _skinName, Widget *_parent, ICroppedRectangle *_croppedParent, std::string_view _name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer () const
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer={}, std::string_view _name={})
virtual void | _resetContainer (bool _update)
bool | _setWidgetState (std::string_view _state)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type>
bool | isType () const
template<typename Type>
Type * | castType (bool _throw=true)
template<typename Type>
const Type * | castType (bool _throw=true) const
virtual | ~IObject ()=default
Public Member Functions inherited from MyGUI::ICroppedRectangle
virtual | ~ICroppedRectangle ()=default
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
virtual | ~UserData ()=default
void | setUserString (std::string_view _key, std::string_view _value)
std::string_view | getUserString (std::string_view _key) const
const MapString & | getUserStrings () const
bool | clearUserString (std::string_view _key)
bool | isUserString (std::string_view _key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType>
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType>
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
virtual | ~WidgetInput ()=default
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (std::string_view _value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()=default
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
ISubWidgetText * | getSubWidgetText () const
ISubWidgetRect * | getSubWidgetMain () const
void | _setTextureName (std::string_view _texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
void | attachItemToNode (ILayer *_layer, ILayerNode *_node) override
void | detachFromLayer () override
void | upLayerItem () override
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()=default
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::MemberObsolete< Button >
void | setButtonPressed (bool _value)
bool | getButtonPressed () const
void | setStateCheck (bool _value)
bool | getStateCheck () const
ImageBox * | getStaticImage () const
void | setImageIndex (size_t _index)
size_t | getImageIndex () const

## Static Public Member Functions
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::TextBox
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::Widget
static std::string_view | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static std::string_view | getClassTypeName ()

## Protected Member Functions
void | initialiseOverride () override
void | shutdownOverride () override
void | onKeyLostFocus (Widget *_new) override
void | onKeySetFocus (Widget *_old) override
void | onMouseLostFocus (Widget *_new) override
void | onMouseSetFocus (Widget *_old) override
void | onMouseButtonPressed (int _left, int _top, MouseButton _id) override
void | onMouseButtonReleased (int _left, int _top, MouseButton _id) override
void | baseUpdateEnable () override
bool | _setState (std::string_view _value)
void | setPropertyOverride (std::string_view _key, std::string_view _value) override
Protected Member Functions inherited from MyGUI::TextBox
void | setPropertyOverride (std::string_view _key, std::string_view _value) override
Protected Member Functions inherited from MyGUI::Widget
| ~Widget () override=default
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, std::string_view _type, std::string_view _skin, const IntCoord &_coord, Align _align, std::string_view _layer, std::string_view _name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point) const
ILayerItem * | getLayerItemByPoint (int _left, int _top) const override
const IntCoord & | getLayerItemCoord () const override
template<typename T>
void | assignWidget (T *&_widget, std::string_view _name)
VectorWidgetPtr | getSkinWidgetsByName (std::string_view _name) const
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Widget * | _getClientWidget ()
| If there is client widget return it, otherwise return this.
const Widget * | _getClientWidget () const
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyButtonPressed (KeyCode _key, Char _char)
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (std::string_view _state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_item, bool _deep)
void | detachFromLayerItemNode (bool _deep)

## Additional Inherited Members
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
EventHandle_WidgetVoid | eventWidgetDestroyed
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin {false}
ICroppedRectangle * | mCroppedParent {nullptr}

## Detailed Description

widget description should be here.

Definition at line 19 of file MyGUI_Button.h.

## Member Typedef Documentation

## ◆ Base

typedef RTTIBase MyGUI::Button::Base

Definition at line 21 of file MyGUI_Button.h.

## ◆ RTTIBase

typedef Button MyGUI::Button::RTTIBase

Definition at line 21 of file MyGUI_Button.h.

## Member Function Documentation

## ◆ _getImageBox()

ImageBox * MyGUI::Button::_getImageBox | ( |  | ) | const

Definition at line 231 of file MyGUI_Button.cpp.

## ◆ _setKeyFocus()

void MyGUI::Button::_setKeyFocus | ( | bool | _focus | ) |

Definition at line 128 of file MyGUI_Button.cpp.

## ◆ _setMouseFocus()

void MyGUI::Button::_setMouseFocus | ( | bool | _focus | ) |

Definition at line 134 of file MyGUI_Button.cpp.

## ◆ _setState()

bool MyGUI::Button::_setState | ( | std::string_view | _value | ) |
| protected

Definition at line 156 of file MyGUI_Button.cpp.

## ◆ baseUpdateEnable()

void MyGUI::Button::baseUpdateEnable | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 140 of file MyGUI_Button.cpp.

## ◆ getClassTypeName()

std::string_view MyGUI::Button::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 21 of file MyGUI_Button.h.

## ◆ getModeImage()

bool MyGUI::Button::getModeImage | ( |  | ) | const

Get Image mode flag

Definition at line 226 of file MyGUI_Button.cpp.

## ◆ getStateSelected()

bool MyGUI::Button::getStateSelected | ( |  | ) | const

Get buton selected.

Definition at line 221 of file MyGUI_Button.cpp.

## ◆ getTypeName()

virtual std::string_view MyGUI::Button::getTypeName | ( |  | ) | const
| inlineoverridevirtual

Get type name as string

Reimplemented from MyGUI::TextBox.

Reimplemented in MyGUI::MenuItem.

Definition at line 21 of file MyGUI_Button.h.

## ◆ initialiseOverride()

void MyGUI::Button::initialiseOverride | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Reimplemented in MyGUI::MenuItem.

Definition at line 16 of file MyGUI_Button.cpp.

## ◆ isType() [1/2]

template<typename Type>

bool MyGUI::Button::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 21 of file MyGUI_Button.h.

## ◆ isType() [2/2]

virtual bool MyGUI::Button::isType | ( | const std::type_info & | _type | ) | const
| inlineoverridevirtual

Compare with selected type

Reimplemented from MyGUI::TextBox.

Reimplemented in MyGUI::MenuItem.

Definition at line 21 of file MyGUI_Button.h.

## ◆ onKeyLostFocus()

void MyGUI::Button::onKeyLostFocus | ( | Widget * | _new | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 38 of file MyGUI_Button.cpp.

## ◆ onKeySetFocus()

void MyGUI::Button::onKeySetFocus | ( | Widget * | _old | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 31 of file MyGUI_Button.cpp.

## ◆ onMouseButtonPressed()

void MyGUI::Button::onMouseButtonPressed | ( | int | _left,
|  | int | _top,
|  | MouseButton | _id )
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 59 of file MyGUI_Button.cpp.

## ◆ onMouseButtonReleased()

void MyGUI::Button::onMouseButtonReleased | ( | int | _left,
|  | int | _top,
|  | MouseButton | _id )
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 70 of file MyGUI_Button.cpp.

## ◆ onMouseLostFocus()

void MyGUI::Button::onMouseLostFocus | ( | Widget * | _new | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 52 of file MyGUI_Button.cpp.

## ◆ onMouseSetFocus()

void MyGUI::Button::onMouseSetFocus | ( | Widget * | _old | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 45 of file MyGUI_Button.cpp.

## ◆ setImageGroup()

void MyGUI::Button::setImageGroup | ( | std::string_view | _name | ) |

Definition at line 177 of file MyGUI_Button.cpp.

## ◆ setImageName()

void MyGUI::Button::setImageName | ( | std::string_view | _name | ) |

Definition at line 184 of file MyGUI_Button.cpp.

## ◆ setImageResource()

void MyGUI::Button::setImageResource | ( | std::string_view | _name | ) |

Definition at line 170 of file MyGUI_Button.cpp.

## ◆ setModeImage()

void MyGUI::Button::setModeImage | ( | bool | _value | ) |

Enable or disable Image mode
Image mode: when button state changed Image on button also change it's picture.
Disabled (false) by default.

Definition at line 150 of file MyGUI_Button.cpp.

## ◆ setPropertyOverride()

void MyGUI::Button::setPropertyOverride | ( | std::string_view | _key,
|  | std::string_view | _value )
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Reimplemented in MyGUI::MenuItem.

Definition at line 190 of file MyGUI_Button.cpp.

## ◆ setStateSelected()

void MyGUI::Button::setStateSelected | ( | bool | _check | ) |

Set button selected state.

Definition at line 119 of file MyGUI_Button.cpp.

## ◆ shutdownOverride()

void MyGUI::Button::shutdownOverride | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from MyGUI::Widget.

Reimplemented in MyGUI::MenuItem.

Definition at line 24 of file MyGUI_Button.cpp.

The documentation for this class was generated from the following files:

- MyGUI_Button.h
- MyGUI_Button.cpp